import base64
import hashlib

import pyaes
import rsa

def md5(string) -> str:
    return hashlib.md5(string.encode('utf-8')).hexdigest()

def sha1(string) -> str:
    return hashlib.sha1(string.encode('utf-8')).hexdigest()

def aes_encrypt(data: bytes, key: bytes) -> bytes:
    aes = pyaes.AESModeOfOperationOFB(key)
    return aes.encrypt(data)

def aes_decrypt(data: bytes, key: bytes) -> bytes:
    aes = pyaes.AESModeOfOperationOFB(key)
    return aes.decrypt(data)

def rsa_encrypt(data: bytes, pubkey) -> bytes:
    if type(pubkey) is str:
        pubkey = rsa.PublicKey.load_pkcs1(pubkey.encode())
    return rsa.encrypt(data, pubkey)

def rsa_decrypt(data: bytes, privkey) -> bytes:
    if type(privkey) is str:
        privkey = rsa.PublicKey.load_pkcs1(privkey.encode())
    return rsa.decrypt(data, privkey)

def base64_encode(data: bytes) -> str:
    return base64.b64encode(data).decode()

def base64_decode(data: str) -> bytes:
    return base64.b64decode(data)