import os

import rsa
import sys


def genkeys(dir=None):
    print("Welcome to NaniCrypt.")
    print("Right now we are generating your keys.")
    pub, priv = rsa.newkeys(1024)
    print("Keys successfully generated!")
    if dir is None:
        print("Public key:")
        print(pub.save_pkcs1().decode())
        print("\nPrivate key:")
        print(priv.save_pkcs1().decode())
    else:
        with open(dir + "/public.key", "w") as f:
            f.write(pub.save_pkcs1())
        with open(dir + "/private.key", "w") as f:
            f.write(priv.save_pkcs1())

if __name__ == '__main__':
    if len(sys.argv) > 1:
        if sys.argv[1] == "--help":
            print(
                "usage: genkeys.py [output dir]\nGenerates keys to be used in NaniCrypt.\nIf output directory is "
                "specified, they will be put there, otherwise - on stdout")
            exit()
        else:
            if os.path.exists(sys.argv[1]):
                genkeys(sys.argv[1])
                exit()
            else:
                print("warn: path not found, falling back to stdout")
                genkeys()
    else:
        genkeys()