import json

import nanicrypt
try:
    import requests
except:
    raise ImportError("requests package is required for networking")
class NaniCryptNetworking:
    def __init__(self, pubkey, base_url: str, salt: str="<powered by NaniCrypt client-server encryption>"):
        self.base_url = base_url
        if self.base_url[-1] != "/":
            self.base_url += "/"
        self.client = nanicrypt.ClientNaniCrypt(pubkey, salt)

    def make_request(self, node, data: dict):
        enc = self.client.encrypt(data)
        rq = requests.post(self.base_url + node, data=enc.json, headers=enc.sign_header)
        try:
            req = rq.json()
            dec = self.client.decrypt(req, enc.key)
        except json.JSONDecodeError:
            raise json.JSONDecodeError("failed to parse server response:\n" + rq.text)
        return dec
